'
'******    *****   ******
'**   **  **   **  **   **      unRAR utility version 1.01
'******   *******  ******       ~~~~~~~~~~~~~~~~~~~~~~~~~~~
'**   **  **   **  **   **         FREE portable version
'**   **  **   **  **   **         ~~~~~~~~~~~~~~~~~~~~~
'
'        Main code                    for QuickBasic
'

'$INCLUDE: 'UNRARHLP.BI'
'$INCLUDE: 'UNRAR.BI'

'---------------------------------------------------------------------------

DECLARE SUB Main ()                             'main program

DIM SHARED CRC32Table(255)     AS LONG
DIM SHARED ArgNames(15)        AS STRING

DIM SHARED MHD                 AS ArchiveHeader
DIM SHARED LHD                 AS FileHeader

DIM SHARED ArgCount            AS INTEGER
DIM SHARED MainCommand         AS STRING
DIM SHARED ArcName             AS STRING
DIM SHARED ArcFileName         AS STRING
DIM SHARED ExtrPath            AS STRING
DIM SHARED PathDiv             AS STRING
DIM SHARED SolidType           AS INTEGER
DIM SHARED ErrCode             AS INTEGER
DIM SHARED ExitCode            AS INTEGER
DIM SHARED ArcFHnd             AS INTEGER
DIM SHARED StdOut              AS INTEGER
DIM SHARED NextBlockPos        AS LONG

Main

ErrorHandler:
  ErrCode = ERR
  RESUME NEXT

SUB CheckArc
'-----------
  IF NOT IsArchive THEN
    PRINT #StdOut,
    PRINT #StdOut, "Bad archive "; ArcName;
    ErrExit EEMPTY, FATAL.ERROR
  END IF
END SUB

FUNCTION CmpName% (Mask AS STRING, Naam AS STRING)
'-------------------------------------------------------------
  DIM LenMask AS INTEGER
  DIM LenName AS INTEGER
  DIM MaskPtr AS INTEGER
  DIM NamePtr AS INTEGER
  DIM MaskPeriod AS INTEGER
  DIM NamePeriod AS INTEGER

  LenMask = LEN(Mask$)
  LenName = LEN(Naam$)
  MaskPeriod = INSTR(Mask, ".")
  NamePeriod = INSTR(Naam, ".")
  MaskPtr = 1
  NamePtr = 1

  DO
    IF MID$(Mask$, MaskPtr, 1) = "*" THEN
      DO WHILE MaskPtr <> MaskPeriod AND MaskPtr <= LenMask
        MaskPtr = MaskPtr + 1
      LOOP
      DO WHILE NamePtr <> NamePeriod AND NamePtr <= LenName
        NamePtr = NamePtr + 1
      LOOP
    END IF
    IF MaskPtr > LenMask THEN
      CmpName = (NamePtr > LenName)
      EXIT FUNCTION
    ELSEIF NamePtr > LenName AND MaskPtr = MaskPeriod THEN
      MaskPtr = MaskPtr + 1
    ELSEIF UCASE$(MID$(Mask$, MaskPtr, 1)) = UCASE$(MID$(Naam$, NamePtr, 1)) _
           OR MID$(Mask$, MaskPtr, 1) = "?" AND NamePtr <> NamePeriod _
           AND NamePtr <= LenName THEN
      MaskPtr = MaskPtr + 1
      NamePtr = NamePtr + 1
    ELSE
      CmpName = FALSE
      EXIT FUNCTION
    END IF
  LOOP
END FUNCTION

FUNCTION CRC& (StartCRC AS LONG, Segment AS INTEGER, Offset AS INTEGER, _
               Size AS LONG)
'-----------------------------------------------------------------------
  DIM i AS LONG
  DIM c AS LONG

  IF CRC32Table(1) = 0 THEN
    InitCRC
  END IF
  NormalizeAddress Segment, Offset
  DEF SEG = Segment
  c = StartCRC
  FOR i = Offset TO Size + Offset - 1
    c = CRC32Table((c AND &HFF&) XOR PEEK(i)) XOR ShiftLR(c, 8)
  NEXT i
  CRC = c
END FUNCTION

SUB ErrExit (ErrCode AS INTEGER, Code AS INTEGER)
'------------------------------------------------------------
  DIM ErrMsg AS STRING
  SELECT CASE ErrCode
    CASE EEMPTY
      ErrMsg = ""
    CASE EWRITE
      ErrMsg = "Write error. Disk full ?"
    CASE EREAD
      ErrMsg = "Read error"
    CASE EOPEN
      ErrMsg = "File open error"
    CASE ECLOSE
      ErrMsg = "File close error"
    CASE EMEMORY
      ErrMsg = "Not enough memory"
    CASE EARCH
      ErrMsg = "Broken archive"
  END SELECT
  IF ErrCode <> EEMPTY THEN
    PRINT #StdOut,
    PRINT #StdOut, " Program aborted"
    PRINT #StdOut, " "; ErrMsg
  END IF
  CLOSE
  EndProgram Code
END SUB

SUB ExecuteCommand
'-----------------
  SELECT CASE MainCommand
  CASE "E", "X", "T"
    PRINT #StdOut,
    PRINT #StdOut, "Command "; MainCommand; " not implemented"
  CASE "V", "L"
    ListArchive
    CLOSE
  CASE ""
    Help
    ExitCode = 0
  CASE ELSE
    Help
    ExitCode = USER.ERROR
  END SELECT
END SUB

SUB Help
'-------
  PRINT #StdOut,
  PRINT #StdOut, " Usage:     UNRAR <command> <archive> <files...>"
  PRINT #StdOut,
  PRINT #StdOut, " <Commands>"
  PRINT #StdOut,
  PRINT #StdOut, " x       Extract files with full path (not implemented)"
  PRINT #StdOut, " e       Extract files to current directory (not implemented)"
  PRINT #StdOut, " t       Test archive files (not implemented)"
  PRINT #StdOut, " v       Verbosely list contents of archive"
  PRINT #StdOut, " l       List contents of archive"
END SUB

SUB InitCRC
'----------
  DIM i AS INTEGER, j AS INTEGER
  DIM c AS LONG

  FOR i = 0 TO 255
    c = i
    FOR j = 0 TO 7
      IF (c AND 1) THEN
        c = ShiftLR(c, 1) XOR &HEDB88320
      ELSE
        c = ShiftLR(c, 1)
      END IF
    NEXT j
    CRC32Table(i) = c
  NEXT i
END SUB

FUNCTION IsArchive
'-----------------
  DIM MarkRead AS STRING * 7
  DIM HeadCRC AS INTEGER, Temp AS INTEGER

  IsArchive = FALSE
  SolidType = 0
  IF (TRead(ArcFHnd, VARSEG(MarkRead), VARPTR(MarkRead), 7) <> 7) THEN
    EXIT FUNCTION
  END IF
  IF MarkRead <> "Rar!" + CHR$(&H1A) + CHR$(7) + CHR$(0) THEN
    EXIT FUNCTION
  END IF
  IF (TRead(ArcFHnd, VARSEG(MHD), VARPTR(MHD), 13) <> 13) THEN
    EXIT FUNCTION
  END IF
  HeadCRC = ToWRD(NOT CRC(&HFFFFFFFF, VARSEG(MHD.HeadType), _
      VARPTR(MHD.HeadType), 11))
  IF NOT (MHD.HeadCRC = HeadCRC) THEN
    PRINT #StdOut,
    PRINT #StdOut, " Archive header broken";
  END IF
  SolidType = (MHD.Flags AND cMHD.SOLID)
  Temp = FSeek(ArcFHnd, MHD.HeadSize - 13, SEEK.CUR)
  IsArchive = TRUE
END FUNCTION

FUNCTION IsProcessFile (ComparePath AS INTEGER)
'----------------------------------------------------
  DIM NumName AS INTEGER, WildCards AS INTEGER
  DIM ArgName AS STRING
  DIM Dir1 AS STRING, Name1 AS STRING
  DIM Dir2 AS STRING, Name2 AS STRING

  FOR NumName = 0 TO ArgCount - 1
    ArgName = ArgNames(NumName)
    WildCards = (INSTR(ArgName, "?") <> 0 OR INSTR(ArgName, "*") <> 0)
    SplitName ArgName, Dir1, Name1
    SplitName ArcFileName, Dir2, Name2
    IF (CmpName(Name1, Name2) AND ((ComparePath = NOT.COMPARE.PATH AND _
        LEN(Dir1) = 0) OR (WildCards AND NOT StrNICmp(Dir1, Dir2, LEN(Dir1))) _
        OR NOT StrNICmp(Dir1, Dir2, 1000))) THEN
      IsProcessFile = TRUE
      EXIT FUNCTION
    END IF
  NEXT NumName
  IsProcessFile = FALSE
END FUNCTION

SUB ListArchive
'--------------
  DIM TotalPackSize AS LONG, TotalUnpSize AS LONG, FileCount AS LONG
  DIM Temp AS INTEGER
  DIM FAttrib AS STRING

  ArcFHnd = FREEFILE
  OPEN ArcName FOR INPUT AS ArcFHnd
  IF ErrCode THEN
    ErrExit EOPEN, FATAL.ERROR
  END IF
  Temp = FSeek(ArcFHnd, 0, SEEK.SET)    'required for FRead
  CheckArc
  PRINT #StdOut,
  PRINT #StdOut, " "
  IF SolidType THEN
    PRINT #StdOut, "Solid ";
  END IF
  IF (MHD.Flags AND cMHD.MULT.VOL) THEN
    IF SolidType THEN
      PRINT #StdOut, "volume ";
    ELSE
      PRINT #StdOut, "Volume ";
    END IF
  ELSE
    IF SolidType THEN
      PRINT #StdOut, "archive ";
    ELSE
      PRINT #StdOut, "Archive ";
    END IF
  END IF
  PRINT #StdOut, UCASE$(ArcName)
  PRINT #StdOut,
  IF MainCommand = "V" THEN
    PRINT #StdOut, " Pathname/Comment"
    PRINT #StdOut, SPACE$(12);
  ELSE
    PRINT #StdOut, " Name       ";
  END IF
  PRINT #StdOut, "      Size   Packed  Ratio   Date   Time  Attr   CRC-32  Meth Ver"
  PRINT #StdOut, STRING$(77, "-");
  DO WHILE ReadBlock(FILE.HEAD) > 0
    IF IsProcessFile(NOT.COMPARE.PATH) THEN
      PRINT #StdOut,
      IF (LHD.Flags AND cLHD.PASSWORD) THEN
        PRINT #StdOut, "*";
      ELSE
        PRINT #StdOut, " ";
      END IF
      IF MainCommand = "V" THEN
        PRINT #StdOut, ArcFileName
        PRINT #StdOut, SPACE$(13);
      ELSE
        PRINT #StdOut, LEFT$(PointToName(ArcFileName) + SPACE$(13), 13);
      END IF
      PRINT #StdOut, USING " ######## ######## "; LHD.UnpSize; LHD.PackSize;
      IF (LHD.Flags AND (cLHD.SPLIT.AFTER OR cLHD.SPLIT.BEFORE)) THEN
        PRINT #StdOut, " Split";
      ELSE
        PRINT #StdOut, USING " ###% "; ToPercent(LHD.PackSize, LHD.UnpSize);
      END IF
      PRINT #StdOut, " "; FDateStr$(LHD.FileDate, DOSDF.AUTO); " "; _
          LEFT$(FTimeStr$(LHD.FileTime), 5); " ";
      IF (ASC(LHD.HostOS) = MS.DOS) THEN
        PRINT #StdOut, FAttrStr$(CINT(LHD.FileAttrib AND &HFF&));
      ELSE
        PRINT #StdOut, SPACE$(5);
      END IF
      PRINT #StdOut, USING " &  m# ##_.#"; RIGHT$(STRING$(8, "0") + _
          DHex$(LHD.FileCRC), 8); ASC(LHD.Method) - &H30; ASC(LHD.UnpVer) \ 10;_
          ASC(LHD.UnpVer) MOD 10;
      IF (LHD.Flags AND cLHD.SPLIT.BEFORE) = 0 THEN
        TotalUnpSize = TotalUnpSize + LHD.UnpSize
        FileCount = FileCount + 1
      END IF
      TotalPackSize = TotalPackSize + LHD.PackSize
    END IF
    Temp = FSeek(ArcFHnd, NextBlockPos, SEEK.SET)
  LOOP
  PRINT #StdOut,
  PRINT #StdOut, STRING$(77, "-")
  PRINT #StdOut, USING "##### ################ ######## ####%"; FileCount; _
    TotalUnpSize; TotalPackSize; ToPercent(TotalPackSize, TotalUnpSize)
  CLOSE ArcFHnd
END SUB

SUB Main
'-------
  StartUp
  PRINT #StdOut,
  PRINT #StdOut, " UNRAR 1.01 freeware portable version      (C) 1994-95 Eugene Roshal"
  PRINT #StdOut, "            adapted for QuickBasic by Hans Lunsing (1995)"
  DIM ArgVar(0) AS STRING
  SplitCommandLine GetArg(ArgVar()), ArgVar()
  ExecuteCommand
  EndProgram ExitCode
END SUB

FUNCTION PointToName$ (Path AS STRING)
'----------------------------------------------------
  DIM BeginName AS INTEGER
  DIM PosColon  AS INTEGER, PosSlash  AS INTEGER
  PosSlash = RInstr(0, Path, "\")
  PosColon = RInstr(0, Path, ":")
  IF PosSlash > PosColon THEN
    BeginName = PosSlash
  ELSE
    BeginName = PosColon
  END IF
  PointToName = MID$(Path, BeginName + 1)
END FUNCTION

FUNCTION ReadBlock% (BlockType AS INTEGER)
'----------------------------------------------
  DIM Size AS INTEGER, Temp AS INTEGER
  DIM HeadCRC AS LONG, LhdCRC AS INTEGER
  MemSetC LEN(LHD), 0, VARSEG(LHD), VARPTR(LHD)
  DO
    Size = TRead(ArcFHnd, VARSEG(LHD), VARPTR(LHD), 32)
    IF (Size <> 0 AND (Size < 7 OR LHD.HeadSize < 7)) THEN
      ErrExit EARCH, FATAL.ERROR
    END IF
    NextBlockPos = FTell(ArcFHnd) - Size + LHD.HeadSize
    IF (LHD.Flags AND LONG.BLOCK) THEN
      NextBlockPos = NextBlockPos + LHD.PackSize
    END IF
    IF (Size = 0 OR BlockType = ALL.HEAD OR ASC(LHD.HeadType) = BlockType) THEN
      EXIT DO
    END IF
    Temp = FSeek(ArcFHnd, NextBlockPos, SEEK.SET)
  LOOP
  IF Size > 0 AND BlockType = FILE.HEAD THEN
    ArcFileName = SPACE$(LHD.NameSize)
    Temp = TRead(ArcFHnd, VARSEG(ArcFileName), SADD(ArcFileName), _
        ToLNG&(LHD.NameSize))
    Size = Size + LHD.NameSize
    HeadCRC = CRC(&h0FFFFFFFF, VARSEG(Lhd.HeadType), VARPTR(Lhd.HeadType), 30)
    LhdCRC = ToWRD(NOT CRC(HeadCRC, VARSEG(ArcFileName), SADD(ArcFileName), _
        ToLNG&(LHD.NameSize)))
    IF NOT (LHD.HeadCRC = LhdCRC) THEN
      PRINT #StdOut,
      PRINT #StdOut, " "; ArcFileName; ": file header broken"
    END IF
    Replace ArcFileName, "\", PathDiv
    Replace ArcFileName, "/", PathDiv
    IF ASC(LHD.HostOS) = MS.DOS THEN
      ArcFileName = UCASE$(ArcFileName)
    END IF
  END IF
  ReadBlock = Size
END FUNCTION

SUB SplitCommandLine (ArgCnt AS INTEGER, ArgVar() AS STRING)
'-----------------------------------------------------------------
  DIM Char AS STRING * 1, Ext AS STRING, ArcFName AS STRING
  DIM i AS INTEGER, Leng AS INTEGER

  ArgCount = 0
  MainCommand = ""
  ArcName = ""
  ExtrPath = ""
  IF ArgCnt = 2 THEN
    MainCommand = "X"
    ArcName = ArgVar(1)
  ELSE
    FOR i = 1 TO ArgCnt - 1
      IF LEN(MainCommand) = 0 THEN
        MainCommand = UCASE$(ArgVar(i))
      ELSEIF LEN(ArcName) = 0 THEN
        ArcName = ArgVar(i)
      ELSE
        Leng = LEN(ArgVar(i))
        Char = RIGHT$(ArgVar(i), 1)
        IF (Leng > 0 AND (Char = ":" OR (Char = "\" OR Char = "/"))) THEN
          ExtrPath = ArgVar(i)
          MID$(ExtrPath, Leng, 1) = PathDiv
        ELSE
          ArgNames(ArgCount AND &HF) = ArgVar(i)
          ArgCount = ArgCount + 1
        END IF
      END IF
    NEXT i
    IF ArgCount = 0 AND LEN(ArcName) > 0 THEN
      ArgNames(ArgCount AND &HF) = "*.*"
      ArgCount = ArgCount + 1
    END IF
    ArcFName = PointToName(ArcName)
    IF INSTR(ArcFName, ".") = 0 THEN
      IF IsUpper(ASC(ArcFName)) THEN
        Ext = ".RAR"
      ELSE
        Ext = ".rar"
      END IF
      ArcName = ArcName + Ext
    END IF
    ArgCount = ArgCount AND &HF
  END IF
END SUB

SUB SplitName (Path AS STRING, Direc AS STRING, NameExt AS STRING)
'----------------------------------------------------------------------
DIM BeginName AS INTEGER
DIM PosColon  AS INTEGER
DIM PosDiv    AS INTEGER

PosDiv = RInstr(0, Path, PathDiv)
PosColon = RInstr(0, Path, ":")
IF PosDiv > PosColon THEN
  BeginName = PosDiv + 1
ELSE
  BeginName = PosColon + 1
END IF
Direc = LEFT$(Path, BeginName - 1)
NameExt = MID$(Path, BeginName)
END SUB

SUB StartUp
'----------
  DIM Fore AS INTEGER, Back AS INTEGER
  'If error goto Errorhandler
  ON ERROR GOTO ErrorHandler
  PathDiv = "\"
  'Show cursor
  LOCATE , , 1
  'Print to stdout to facilitate redirection of output
  StdOut = FREEFILE
  OPEN "CONS:" FOR OUTPUT AS StdOut
END SUB

FUNCTION StrNICmp (Str1 AS STRING, Str2 AS STRING, MaxLen AS INTEGER)
'-------------------------------------------------------------------
  IF MaxLen = 0 THEN
    StrNICmp = FALSE
  ELSE
    IF MaxLen > LEN(Str1) THEN MaxLen = LEN(Str1)
    IF MaxLen > LEN(Str2) THEN MaxLen = LEN(Str2)
    StrNICmp = (UCASE$(LEFT$(Str1, MaxLen)) <> UCASE$(LEFT$(Str2, MaxLen)))
  END IF
END FUNCTION

SUB TCLose (ArcFHnd AS INTEGER)
'---------------------------------
  CLOSE ArcFHnd
  IF ErrCode THEN
    ErrExit ECLOSE, FATAL.ERROR
  END IF
END SUB

FUNCTION ToPercent (N1 AS LONG, N2 AS LONG)
'--------------------------------------------------------
  DIM M1 AS LONG, M2 AS LONG
  IF M1 > 10000 THEN
    M1 = N1 \ 100
    M2 = N2 \ 100
  ELSE
    M1 = N1
    M2 = N2
  END IF
  SELECT CASE M2
  CASE 0
    ToPercent = 0
  CASE IS < M1
    ToPercent = 100
  CASE ELSE
    ToPercent = CINT((M1 * 100) \ M2)
  END SELECT
END FUNCTION

FUNCTION TRead (FHnd AS INTEGER, BufferSeg AS INTEGER, BufferPtr AS INTEGER, _
                Leng AS LONG)
'-------------------------------------------------------------------------
  DIM Code AS INTEGER
  Code = FRead(FHnd, Leng, 1, BufferSeg, BufferPtr)
  IF Code = -1 THEN
    ErrExit EREAD, FATAL.ERROR
  END IF
  TRead = Code
END FUNCTION

