'
'******    *****   ******
'**   **  **   **  **   **      unRAR utility version 1.01
'******   *******  ******       ~~~~~~~~~~~~~~~~~~~~~~~~~~~
'**   **  **   **  **   **         FREE portable version
'**   **  **   **  **   **         ~~~~~~~~~~~~~~~~~~~~~
'
'     Definitions header               for QuickBasic
'


CONST UNP.VER        = 15               'current version of unpacking method


' Exit codes
CONST SUCCESS        = 0
CONST WARNING        = 1
CONST FATAL.ERROR    = 2
CONST CRC.ERROR      = 3
CONST LOCK.ERROR     = 4
CONST WRITE.ERROR    = 5
CONST OPEN.ERROR     = 6
CONST USER.ERROR     = 7
CONST MEMORY.ERROR   = 8
CONST READ.ERROR     = 9
CONST USER.BREAK     = 255

' Status for path comparison
CONST COMPARE.PATH           = 0
CONST NOT.COMPARE.PATH       = 1

' Archive header flags
CONST cMHD.MULT.VOL   = 1
CONST cMHD.COMMENT    = 2
CONST cMHD.LOCK       = 4
CONST cMHD.SOLID      = 8

' File header flags
CONST cLHD.SPLIT.BEFORE      = 1
CONST cLHD.SPLIT.AFTER       = 2
CONST cLHD.PASSWORD          = 4
CONST cLHD.COMMENT           = 8
CONST SKIP.IF.UNKNOWN        = &h4000
CONST LONG.BLOCK             = &h8000

' Archive internal block types
CONST ALL.HEAD       = 0
CONST MARK.HEAD      = &h72
CONST MAIN.HEAD      = &h73
CONST FILE.HEAD      = &h74
CONST COMM.HEAD      = &h75

' HostOS code
CONST MS.DOS         = 0

' Error codes
CONST EEMPTY         = -1
CONST EWRITE         = 1
CONST EREAD          = 2
CONST EOPEN          = 3
CONST ECLOSE         = 4
CONST ESEEK          = 5
CONST EMEMORY        = 6
CONST EARCH          = 7

' Headers definitions

TYPE MarkHeader
  Mark          AS STRING * 5
  HeadSize      AS INTEGER
END TYPE

TYPE ArchiveHeader
  HeadCRC       AS INTEGER
  HeadType      AS STRING * 1
  Flags         AS INTEGER
  HeadSize      AS INTEGER
  Reserved      AS STRING * 6
END TYPE

TYPE FileHeader
  HeadCRC       AS INTEGER
  HeadType      AS STRING * 1
  Flags         AS INTEGER
  HeadSize      AS INTEGER
  PackSize      AS LONG
  UnpSize       AS LONG
  HostOS        AS STRING * 1
  FileCRC       AS LONG
  FileTime      AS INTEGER
  FileDate      AS INTEGER
  UnpVer        AS STRING * 1
  Method        AS STRING * 1
  NameSize      AS INTEGER
  FileAttrib    AS LONG
END TYPE

' Procedure declarations

DECLARE SUB      StartUp()                      'some startup code
DECLARE SUB SplitCommandLine (ArgCnt AS INTEGER, ArgVar() AS STRING)
                                                'parses command string
DECLARE FUNCTION CmpName% (Mask AS STRING, Naam AS STRING)
                                                'checks name for mask
DECLARE FUNCTION PointToName$ (Path AS STRING)  'returns filename
DECLARE SUB      SplitName(Path AS STRING, Direc AS STRING, NameExt AS STRING)
                                                'splits pathname
DECLARE SUB      ExecuteCommand()               'executes extr. command
DECLARE SUB      ListArchive()                  'lists archive contents
DECLARE SUB      Help()                         'prints usage help
DECLARE SUB      ErrExit (ErrCode AS INTEGER, Code AS INTEGER)
                                                'exits with error code
DECLARE FUNCTION TRead(FHnd AS INTEGER, BufferSeg AS INTEGER, _
                 BufferPtr AS INTEGER, Leng AS LONG)
                                                'reads with checking
DECLARE SUB      TCLose (ArcFHnd AS INTEGER)    'closes with checking
DECLARE FUNCTION IsArchive%()                   'checks for RAR archive signature
DECLARE SUB      CheckArc()                     'similar but with exit
DECLARE FUNCTION StrNICmp(Str1 AS STRING, Str2 AS STRING, MaxLen AS INTEGER)
                                                'compares strings
DECLARE FUNCTION ToPercent (N1 AS LONG, N2 AS LONG)
                                                'calculates percentage
DECLARE FUNCTION ReadBlock%(BlockType AS INTEGER)
                                                'reads archive block
DECLARE FUNCTION IsProcessFile (ComparePath AS INTEGER)
                                                'should file be processed
DECLARE SUB      InitCRC()                      'initializes CRC table
DECLARE FUNCTION CRC&(StartCRC AS LONG, Segment AS INTEGER, Offset AS INTEGER, _
                 Size AS LONG)                  'calculates CRC

