DEFINT A-Z

'$INCLUDE: 'qb.bi'
'$INCLUDE: 'unrarhlp.bi'

CONST PSPENVSEG = &H2C

CONST MAXPARAMS = 16
REDIM SHARED ArgIndex(1 TO MAXPARAMS)            AS INTEGER

DIM SHARED CmdLine      AS STRING
DIM SHARED DidCount     AS INTEGER
DIM SHARED LenCmd       AS INTEGER
DIM SHARED MaxCount     AS INTEGER

FUNCTION ArgC%
'------------------------------
	DIM i1 AS INTEGER, i2 AS INTEGER
	DIM Count AS INTEGER

	CmdLine = COMMAND$
	LenCmd = LEN(CmdLine)
	IF LenCmd = 0 THEN
		'Count also includes program path\name
		ArgC% = 1
		EXIT FUNCTION
	END IF
	MaxCount = MAXPARAMS
	DO
		REDIM ArgIndex(1 TO MaxCount) AS INTEGER
		Count = 0
		i1 = 1
		DO
			DO
	i2 = INSTR(i1, CmdLine, " ")
	IF i2 = 0 THEN i2 = LenCmd + 1
	IF i2 > i1 THEN EXIT DO
	i1 = i1 + 1
			LOOP
			Count = Count + 1
			IF Count < MaxCount THEN
	ArgIndex(Count) = i1
			END IF
			i1 = i2
		LOOP UNTIL i2 > LenCmd
		IF Count < MaxCount THEN EXIT DO
		MaxCount = Count + 1
	LOOP
	DidCount = TRUE
	ArgIndex(Count + 1) = i2
	'Count also includes program path\name
	ArgC% = Count + 1
END FUNCTION

FUNCTION ArgV$ (Index AS INTEGER)
'-------------------------------------------
	DIM Count AS INTEGER
	DIM Reg AS RegTypeX
	IF NOT DidCount THEN
		Count = ArgC
	END IF
	IF Index = 0 THEN
		Reg.AX = &H3000
		CALL InterruptX(&H21, Reg, Reg)
		IF (Reg.AX AND 15) < 3 THEN
			ArgV = ""
		ELSE
			ArgV = GetProgramName
		END IF
	ELSEIF Index < 0 OR Index >= MaxCount THEN
		ArgV = ""
	ELSE
		ArgV = RTRIM$(MID$(CmdLine, ArgIndex(Index), ArgIndex(Index + 1) - ArgIndex(Index)))
	END IF
END FUNCTION

FUNCTION DHex$ (LongInt AS LONG)
'------------------------------------------------------
	DHex = RIGHT$(STRING$(7, "0") + HEX$(LongInt), 8)
END FUNCTION

SUB EndProgram (ExitCode AS INTEGER)
	END
END SUB

FUNCTION FAttrStr$ (FAttr AS INTEGER)
'----------------------------------------------
	DIM Temp AS STRING

	IF (FAttr AND DOSFA.LABEL) THEN
		Temp = "<VOL>"
	ELSEIF (FAttr AND DOSFA.DEVICE) THEN
		Temp = "<DEV>"
	ELSE
		Temp = STRING$(5, ".")
		IF (FAttr AND DOSFA.DIREC) THEN MID$(Temp, 1, 1) = "D"
		IF (FAttr AND DOSFA.RDONLY) THEN MID$(Temp, 2, 1) = "R"
		IF (FAttr AND DOSFA.HIDDEN) THEN MID$(Temp, 3, 1) = "H"
		IF (FAttr AND DOSFA.SYSTEM) THEN MID$(Temp, 4, 1) = "S"
		IF (FAttr AND DOSFA.ARCH) THEN MID$(Temp, 5, 1) = "A"
	END IF
	FAttrStr = Temp
END FUNCTION

FUNCTION FDateStr$ (FileDate AS INTEGER, Fmt AS INTEGER)
'-----------------------------------------------------------------------
'  Fmt DOSDF.AUTO - auto detection
'      DOSDF.USA  - mm-dd-yy
'      DOSDF.EUR  - dd-mm-yy  (default)
'      DOSDF.JAP  - yy-mm-dd
'-----------------------------------------------------------------------
	DIM fDay   AS INTEGER
	DIM fYear  AS INTEGER
	DIM fMonth AS INTEGER
	DIM Reg    AS RegTypeX
	DIM Temp   AS STRING
	DIM fDate(2) AS INTEGER, iDate(2) AS INTEGER

	IF Fmt = DOSDF.AUTO THEN
		DIM CountryInfo AS STRING
		CountryInfo = SPACE$(40)
		Reg.AX = &H3800
		Reg.DS = VARSEG(CountryInfo)
		Reg.DX = SADD(CountryInfo)
		CALL InterruptX(&H21, Reg, Reg)
		Fmt = ASC(CountryInfo)
	END IF
	SELECT CASE Fmt
	CASE DOSDF.USA
		iDate(0) = 1
		iDate(1) = 0
		iDate(2) = 2
	CASE DOSDF.JAP
		iDate(0) = 2
		iDate(1) = 1
		iDate(2) = 0
	CASE ELSE
		iDate(0) = 0
		iDate(1) = 1
		iDate(2) = 2
	END SELECT

	fDate(2) = (FileDate \ 512 + 1980) MOD 100      'Year
	fDate(1) = (FileDate AND &H1E0) \ 32            'Month
	fDate(0) = FileDate AND &H1F                    'Day

	Temp = STRING$(8, "-")
	MID$(Temp, 1, 2) = RIGHT$("0" + LTRIM$(STR$(fDate(iDate(0)))), 2)
	MID$(Temp, 4, 5) = RIGHT$("0" + LTRIM$(STR$(fDate(iDate(1)))), 2)
	MID$(Temp, 7, 8) = RIGHT$("0" + LTRIM$(STR$(fDate(iDate(2)))), 2)
	FDateStr = Temp
END FUNCTION

FUNCTION FRead& (FHnd AS INTEGER, NumItems AS LONG, ItemSize AS INTEGER, BufferSeg AS INTEGER, BufferPtr AS INTEGER)
'-----------------------------------------------------------------------------
	DIM Bytes AS LONG, ReadBytes AS LONG
	DIM Blocks AS INTEGER, BlockSize AS LONG, Rest AS LONG, ToRead AS LONG
	DIM i AS INTEGER, OK AS INTEGER, EndFile AS INTEGER
	DIM DOSFHnd AS INTEGER
	DIM Reg AS RegTypeX

	Bytes = NumItems * ItemSize
	IF Bytes = 0 THEN
		FRead = 0
		EXIT FUNCTION
	END IF
	BlockSize = 65520
	Blocks = Bytes \ BlockSize
	Rest = Bytes MOD BlockSize
	ReadBytes = 0
	DOSFHnd = FILEATTR(FHnd, 2)
	ToRead = BlockSize
	NormalizeAddress BufferSeg, BufferPtr
	FOR i = 1 TO Blocks
		GOSUB ReadBlock
		IF (EndFile OR NOT OK) THEN
			FRead = -1
			EXIT FUNCTION
		END IF
	NEXT i
	IF Rest THEN
		ToRead = Rest
		GOSUB ReadBlock
	END IF
	IF OK THEN
		FRead = ReadBytes \ ItemSize
	ELSE
		FRead = -1
	END IF
	EXIT FUNCTION

ReadBlock:
	Reg.AX = &H3F00
	Reg.BX = DOSFHnd
	Reg.CX = ToRead
	Reg.DX = BufferPtr
	Reg.DS = BufferSeg
	CALL InterruptX(&H21, Reg, Reg)
	OK = (Reg.Flags AND 1) = 0
	IF OK THEN
		ReadBytes = ReadBytes + Reg.AX
		EndFile = (Reg.AX <> ToRead)
	END IF
	RETURN
END FUNCTION

FUNCTION FSeek% (FHnd AS INTEGER, Offset AS LONG, StartPosition AS INTEGER)
'---------------------------------------------------------------
' Function: sets position in a file
'
' StartPosition can have the following values:
' SEEK.SET = 0: Seek from beginning of file
' SEEK.CUR = 1: Seek from current position
' SEEK.END = 2: Seek from end of file
'---------------------------------------------------------------
	DIM Reg AS RegTypeX

	Reg.AX = &H4200 OR (StartPosition AND &HFF)
	Reg.BX = FILEATTR(FHnd, 2)
	Reg.CX = ToWRD(Offset \ 65536)
	Reg.DX = ToWRD(Offset MOD 65536)
	CALL InterruptX(&H21, Reg, Reg)
	IF (Reg.Flags AND 1) THEN
		FSeek = Reg.AX
	ELSE
		FSeek = 0
	END IF
END FUNCTION

FUNCTION FTell& (FHnd AS INTEGER)
'------------------------------------------------
' Function: Gets the current file position
'------------------------------------------------
	DIM Reg AS RegTypeX

	Reg.AX = &H4200 OR SEEK.CUR
	Reg.BX = FILEATTR(FHnd, 2)
	Reg.CX = 0
	Reg.DX = 0
	CALL InterruptX(&H21, Reg, Reg)
	FTell& = 65536 * Reg.DX + Reg.AX
END FUNCTION

FUNCTION FTimeStr$ (FileTime AS INTEGER)
'-------------------------------------------------
	DIM fSec    AS INTEGER
	DIM fMinute AS INTEGER
	DIM fHour   AS INTEGER
	DIM Temp    AS STRING

	fHour = FileTime \ 2048
	fMinute = (FileTime AND &H7E0) \ 32
	fSec = (FileTime AND &H1F) * 2

	Temp = STRING$(8, ":")
	MID$(Temp, 1, 2) = RIGHT$("0" + LTRIM$(STR$(fHour)), 2)
	MID$(Temp, 4, 5) = RIGHT$("0" + LTRIM$(STR$(fMinute)), 2)
	MID$(Temp, 7, 8) = RIGHT$("0" + LTRIM$(STR$(fSec)), 2)
	FTimeStr = Temp
END FUNCTION

FUNCTION GetArg% (ArgVar() AS STRING)
'-------------------------------------------
	DIM ArgCnt AS INTEGER, i AS INTEGER
	ArgCnt = ArgC
	REDIM ArgVar(ArgCnt - 1) AS STRING
	FOR i = 0 TO ArgCnt - 1
		ArgVar(i) = ArgV(i)
	NEXT i
	GetArg = ArgCnt
END FUNCTION

FUNCTION GetProgramName$
'---------------------------------
	DIM i AS INTEGER, j AS INTEGER
	DIM Reg AS RegType

	Reg.AX = &H6200
	CALL Interrupt(&H21, Reg, Reg)
	DEF SEG = Reg.BX
	DEF SEG = PeekWord(PSPENVSEG)
	i = 0
	DO WHILE PEEK(i) <> 0
		i = i + 1
	LOOP
	i = i + 4
	j = i
	DO WHILE PEEK(j) <> 0
		j = j + 1
	LOOP
	GetProgramName = PeekString$(i, j - i)
END FUNCTION

FUNCTION IsUpper (AsciiCode AS INTEGER)
'--------------------------------------------------
	IsUpper = (AsciiCode >= 65 AND AsciiCode <= 90)
END FUNCTION

SUB MemSetC (NumBytes AS INTEGER, Char AS INTEGER, Segment AS INTEGER, Offset AS INTEGER)
'------------------------------------------------------------------------
	DIM i AS INTEGER
	NormalizeAddress Segment, Offset

	DEF SEG = Segment
	FOR i = Offset TO Offset - 1 + NumBytes
		POKE i, Char
	NEXT i
END SUB

SUB NormalizeAddress (Segment AS INTEGER, Offset AS INTEGER)
'----------------------------------------------------------
	DIM LongSeg AS LONG
	LongSeg = ((CLNG(Segment) AND &HFFFF&) + (CLNG(Offset) AND &HFFFF&) \ 16)
	Segment = (LongSeg AND &H7FFF&) - (LongSeg AND &H8000&)
	Offset = Offset AND 15
END SUB

FUNCTION PeekString$ (Offset AS INTEGER, Length AS INTEGER)
'----------------------------------------------------------
	IF Length > 0 THEN
		PeekString$ = SPACE$(Length)
		FOR i = 1 TO Length
			MID$(PeekString$, i, 1) = CHR$(PEEK(Offset - 1 + i))
		NEXT i
	ELSE
		PeekString$ = ""
	END IF
END FUNCTION

FUNCTION PeekWord% (Offset AS INTEGER)
'-------------------------------------
	DIM Hi AS INTEGER
	Hi = PEEK(Offset + 1)
	PeekWord = CLNG(PEEK(Offset)) + 256 * ((Hi AND &H7F) - (Hi AND &H80))
END FUNCTION

SUB Replace (InStrg AS STRING, WhatStr AS STRING, WithStr AS STRING)
'-----------------------------------------------------------------
	DIM i AS INTEGER
	IF LEN(WhatStr$) = 0 OR WithStr$ = WhatStr$ THEN EXIT SUB
	i = 0
	DO
		i = INSTR(i + 1, InStrg$, WhatStr$)
		IF i = 0 THEN EXIT DO
		Instr$ = LEFT$(InStrg$, i - 1) + WithStr$ + MID$(InStrg$, i + LEN(WhatStr$))
	LOOP
END SUB

FUNCTION RInstr (ScanEnd AS INTEGER, ScanString AS STRING, CmpString AS STRING)
'-----------------------------------------------------------------------
' Functie: Searches a string for a substring from right to left

' Parameters:
' ScanEnd    - position from which to search.
'              If 0 ScanString is searched from its end.
' ScanString - string to search
' CmpString  - string to search for
'-----------------------------------------------------------------------
	DIM i AS INTEGER
	DIM LenCmp AS INTEGER

	IF ScanEnd = 0 THEN
		ScanEnd = LEN(ScanString)
	END IF
	LenCmp = LEN(CmpString)
	i = ScanEnd - LenCmp + 1
	IF i < 0 THEN
		i = 0
	ELSE
		DO WHILE i > 0
			IF MID$(ScanString, i, LenCmp) = CmpString THEN
	EXIT DO
			END IF
			i = i - 1
		LOOP
	END IF
	RInstr = i
END FUNCTION

FUNCTION ShiftLR& (LongInt AS LONG, Bits AS INTEGER)
'---------------------------------------------------
	DIM i AS INTEGER
	DIM Temp AS LONG
	SELECT CASE Bits
	CASE 1 TO 31
		Temp = ((LongInt AND &H7FFFFFFF) \ 2) OR ((LongInt < 0) AND &H40000000)
		FOR i = 2 TO Bits
			Temp = Temp \ 2
		NEXT i
		ShiftLR& = Temp
	CASE IS <= 0                          'No left shift when negative
		ShiftLR = LongInt
	CASE ELSE
		ShiftLR = 0
	END SELECT
END FUNCTION

FUNCTION ToLNG& (ShortInt AS INTEGER)
'------------------------------------
	ToLNG = CLNG(ShortInt) AND &HFFFF&
END FUNCTION

FUNCTION ToWRD% (LongInt AS LONG)
'--------------------------------
	ToWRD = (LongInt AND &H7FFF&) - (LongInt AND &H8000&)
END FUNCTION

